include get.e
include file.e
constant FILE_HEADER_SIGNATURE = #04034B50
sequence buffer
integer buffer_ptr
function readLong()
    atom ret
    ret = buffer[buffer_ptr] +
	  (buffer[buffer_ptr+1] * 256) +
	  (buffer[buffer_ptr+2] * 65536) +
	  (buffer[buffer_ptr+3] * 16777216)
    buffer_ptr += 4
    return ret
end function
function readInt()
    integer ret
    ret = buffer[buffer_ptr] + (buffer[buffer_ptr+1] * 256)
    buffer_ptr += 2
    return ret
end function
function ReadLocalFile(integer f)
    object x
    sequence r
    buffer = get_bytes(f, 30)
    if length(buffer) < 30 then
	x = seek(f, where(f)-length(buffer))
	return -1
    end if
    r = repeat(0,14)
    buffer_ptr = 1
    r[1] = readLong()
    if r[1] != FILE_HEADER_SIGNATURE then
	x = seek(f, where(f)-30)
	return 0
    end if
    r[2] = readInt()
    r[3] = readInt()
    r[4] = readInt()
    r[5] = readInt()
    r[6] = readInt()
    r[7] = readLong()
    r[8] = readLong()
    r[9] = readLong()
    r[10] = readInt()
    r[11] = readInt()
    r[12] = get_bytes(f,r[10])
    if length(r[12]) != r[10] then
	return -2
    end if
    r[13] = get_bytes(f,r[11])
    if length(r[13]) != r[11] then
	return -3
    end if
    r[14] = get_bytes(f,r[8])
    if length(r[14]) != r[8] then
	return -4
    end if
    if remainder(floor(r[3]/power(2,3)),2) then
	r = r & {0,0,0}
	buffer = get_bytes(f, 12)
	if length(buffer) != 12 then
	    return -5
	end if
	buffer_ptr = 1
	r[15] = readLong()
	r[16] = readLong()
	r[17] = readLong()
    end if
    return r
end function
global constant Z_NAME = 1,
		Z_COMPRESSED = 2,
		Z_UNCOMPRESSED = 3,
		Z_COMMENTS = 4,
		Z_METHOD = 5
global constant Z_STORED = 0,
		Z_SHRUNK = 1,
		Z_REDUCED1 = 2,
		Z_REDUCED2 = 3,
		Z_REDUCED3 = 4,
		Z_REDUCED4 = 5,
		Z_IMPLODED = 6,
		Z_TOKENIZED = 7,
		Z_DEFLATED = 8,
		Z_DEFLATEDPLUS = 9,
		Z_PKWAREDCLI = 10
global function ReadZipFileInfo(sequence fileName)
    integer f
    object s
    sequence r
    r = {}
    f = open(fileName, "rb")
    if f = -1 then
	return -1
    end if
    s = ReadLocalFile(f)
    while sequence(s) do
	r = append(r,{s[12],s[8],s[9],s[13],s[4]})
	s = ReadLocalFile(f)
    end while
    close(f)
    return r
end function
